Testing ag-Grid
We will walk through how you can use Protractor
and Jasmine
to do Unit & End to End (e2e)
testing with ag-Grid in this section.
Unit Testing with Jasmine - Waiting for the API
In order to unit test your application you need to ensure that the Grid API is available - the
best way to do this is to set a flag when the Grid's gridReady
event fires, but this requires an application code change.
An alternative is to use a utility function that polls until the API has been set on the GridOptions
:
function waitForGridApiToBeAvailable(gridOptions, success) {
// recursive without a terminating condition,
// but jasmines default test timeout will kill it (jasmine.DEFAULT_TIMEOUT_INTERVAL)
if(gridOptions.api) {
success()
} else {
setTimeout(function () {
waitForGridApiToBeAvailable(gridOptions, success);
}, 500);
}
}
Once the API is ready, we can then invoke Grid API
and ColumnApi
methods:
it('select all button selects all rows', () => {
selectAllRows(); // selectAllRows is a global function created in the application code
expect(gridOptionsUnderTest.api.getSelectedNodes().length).toEqual(3);
});
End to End (e2e) Testing
These recipes below are suggestions - there are many ways to do End to End testing, what we document below is what we use here at ag-Grid.
We do not document how to use either Protractor
and Jasmine
in depth here - please see either the
Protractor or
Jasmine for information around either of these tools.
We only describe how these tools can be used to test ag-Grid below.
End to End testing can be fragile. If you change something trivial upstream it can have a big impact on an End to End test, so we recommend using End to End tests in conjuction with unit tests. It's often easier to find and fix a problem at the unit testing stage than it is in the end to end stage.
Testing Dependencies
npm install protractor webdriver-manager --save-dev
# optional dependencies - if you're using TypeScript
npm install @types/jasmine @types/selenium-webdriver --save-dev
Note you can install protractor
and webdriver-manager
globally if you'd prefer, which would allow
for shorter commands when executing either of these tools.
We now need to update the webdriver:
./node_modules/.bin/webdriver-manager update
This can be added to your package.json for easier packaging and repeatability:
"scripts": {
"postinstall": "webdriver-manager update"
}
Selenium Server
You can either start & stop your tests in a script, or start the Selenium server separately, running your tests against it.
Remember that the interaction between your tests and the browser is as follows:
[Test Scripts] < ------------ > [Selenium Server] < ------------ > [Browser Drivers]
We'll run the server separately to begin with here:
./node_modules/.bin/webdriver-manager start
Sample Configuration
// conf.js
exports.config = {
framework: 'jasmine',
specs: ['spec.js']
}
// Here we specify the Jasmine testing framework as well as our test to run.
Sample Test
If you're testing against a non-Angular application then you need to tell Protractor
not to wait for Angular by adding this to either your configuration or your tests: browser.ignoreSynchronization = true;
For this test we'll testing a simple JavaScript based grid which can be found at the Getting Started -> JavaScript Section:

Checking Headers
Let's start off by checking the headers are the ones we're expecting. We can do this by retrieving
all div
's that have the ag-header-cell-text
class:
// spec.js
describe('ag-Grid Protractor Test', function () {
// not an angular application
browser.ignoreSynchronization = true;
beforeEach(() => {
browser.get("https://www.ag-grid.com/example-runner/vanilla.php?section=javascript-grid&example=hello-world");
});
it('should have expected column headers', () => {
element.all(by.css(".ag-header-cell-text"))
.map(function (header) {
return header.getText()
}).then(function (headers) {
expect(headers).toEqual(['Make', 'Model', 'Price']);
});
});
});
We can now run our test by executing the following command:
./node_modules/.bin/protractor conf.js
# or if protractor is installed globally protractor conf.js
Checking Grid Data
We can match grid data by looking for rows by matching div[row="<row id>"]
and then column
values within these rows by looking for div
's with a class of .ag-cell-value
:
it('first row should have expected grid data', () => {
element.all(by.css('div[row="0"] div.ag-cell-value'))
.map(function (cell) {
return cell.getText();
})
.then(function (cellValues) {
expect(cellValues).toEqual(["Toyota", "Celica", "35000"]);
});
});
We can add this to spec.js
and run the tests as before.
ag-Grid Testing Utilities
These utilities scripts should still be considered beta and are subject to change. Please provide feedback to the GitHub repository.
Here at ag-Grid we use a number of utility functions that make it easier for us to test ag-Grid functionality.
The utilities can be installed & imported as follows:
Installing:
npm install ag-grid-testing --save-dev
Importing:
let ag_grid_utils = require("ag-grid-testing");
verifyRowDataMatchesGridData
Compares Grid data to provided data. The order of the data provided should correspond to the order within
the grid. The property names should correspond to the colId
's of the columns.
ag_grid_utils.verifyRowDataMatchesGridData(
[
{
// first row
"name": "Amelia Braxton",
"proficiency": "42%",
"country": "Germany",
"mobile": "+960 018 686 075",
"landline": "+743 1027 698 318"
},
// more rows...
]
);
verifyCellContentAttributesContains
Userful when there is an array of data within a cell, each of which is witing an attribute (for example an image).
ag_grid_utils.verifyCellContentAttributesContains(1, "3", "src", ['android', 'mac', 'css'], "img");
allElementsTextMatch
Verifies that all elements text (ie the cell value) matches the provided data. Usf
ag_grid_utils.allElementsTextMatch(by.css(".ag-header-cell-text"),
['#', 'Name', 'Country', 'Skills', 'Proficiency', 'Mobile', 'Land-line']
);
clickOnHeader
Clicks on a header with the provided headerName
.
ag_grid_utils.clickOnHeader("Name");
getLocatorForCell
Provides a CSS Locator
for a grid cell, by row & id and optionally a further CSS selector.
ag_grid_utils.getLocatorForCell(0, "make")
ag_grid_utils.getLocatorForCell(0, "make", "div.myClass")
getCellContentsAsText
Returns the cell value (as text) for by row & id and optionally a further CSS selector.
ag_grid_utils.getCellContentsAsText(0, "make")
.then(function(cellValue) {
// do something with cellValue
});
ag_grid_utils.getCellContentsAsText(0, "make", "div.myClass")
.then(function(cellValue) {
// do something with cellValue
});
- Unit Testing with Jasmine - Waiting for the API
- End to End (e2e) Testing
- Testing Dependencies
- Selenium Server
- Sample Configuration
- Sample Test
- Checking Headers
- Checking Grid Data
- ag-Grid Testing Utilities
- verifyRowDataMatchesGridData
- verifyCellContentAttributesContains
- allElementsTextMatch
- clickOnHeader
- getLocatorForCell
- getCellContentsAsText
- Configuring the Test Module
- Testing via the Grid API
- Testing Grid Contents
- Testing User Supplied Components
- Applying Styles To The Grid When Testing
- Waiting for the Grid to be Initialised
- Waiting for Grid Components to be Instantiated
- Waiting for the Grid to be Initialised
- Testing User Supplied Components
- Jest Configuration
- <code class="language-text">SyntaxError: Cannot use import statement outside a module</code>

Here we give some hints on testing AG Grid as part of your application.
End to End (e2e) Testing Copy Link
We recommend using e2e tests to validate AG Grid as part of your application.
There are a number of tools available to help with this, such as Playwright, Cypress or Selenium.
e2e tests are recommended so that AG Grid is run inside a real browser. Mocked browser environments (such as jsdom) can be used for simple unit testing cases, but their limitations can lead to confusing test results.
End to End (e2e) Testing Examples Copy Link
There are a number of end-to-end test examples available in the AG Grid repo which demonstrate how to use Test Ids to test AG Grid. While these tests use Playwright, we do not necessarily recommend one e2e framework over another.
Test IDs Copy Link
Enabling Test IDs Copy Link
Many testing libraries allow targeting the data-testid attribute to locate elements on the page to use for assertions or actions. AG Grid provides support for attaching this attribute to many of the interactive elements in the grid. This is achieved by calling the setupAgTestIds function. This should only be used in a test or development environment, not in production.
// Application code
import { setupAgTestIds } from 'ag-grid-community'
if(process.env.NODE_ENV !== "production"){
// Setup test IDs for all instances of AG Grid that are created after this call.
setupAgTestIds();
}By default the test ID attribute will be data-testid but this can be customised via the testIdAttribute option. This is useful if you want to use a different attribute name, for example data-customattr.
// Application code
setupAgTestIds({ testIdAttribute: 'data-customattr' }) Using Test IDs Copy Link
With Test IDs enabled on your application's grids it is then possible to query elements via the agTestIdFor helper methods.
// Test code
import { agTestIdFor } from 'ag-grid-community';
// in your test case
const rowId = 'toyota';
const colId = 'make';
const cellTestId = agTestIdFor.cell(rowId, colId);
// Using Playwright
const checkbox = page.getByTestId(cellTestId);
// Testing Library
const checkbox = findByTestId(cellTestId); Using Test Id Wrapper Copy Link
When writing tests using Test IDs, the code can become verbose. To reduce boilerplate use the wrapAgTestIdFor function to create a wrapper around the agTestIdFor methods for the given test context.
// Test code
import { agTestIdFor, wrapAgTestIdFor } from 'ag-grid-community';
// Before
await expect(page.getByTestId(agTestIdFor.headerCell('toyota'))).toBeVisible();
await expect(page.getByTestId(agTestIdFor.cell('toyota', 'make'))).toBeVisible();
const agIdFor = wrapAgTestIdFor((testId) => page.getByTestId(testId));
// After
await expect(agIdFor.headerCell('toyota')).toBeVisible();
await expect(agIdFor.cell('toyota', 'make')).toBeVisible(); Testing your Vue Application in NodeJS Copy Link
We will walk through how you can test AG Grid as part of your Vue application, using default build tools provided when using the Vue CLI utility.
Waiting for the Grid to be Initialised Copy Link
Due to the asynchronous nature of AG Grid we cannot simply mount the Grid and assume it'll be ready for testing in the next step - we need to wait for the Grid to be ready before testing it.
We can do this in one of two ways - wait for the gridReady event to be fired, or wait for the Grid API to be set.
The first requires a code change and can be tricky to hook into - the latter is unobtrusive and easier to use.
We can create a utility function that will wait for the Grid API to be set for a set amount of time/attempts:
const ensureGridApiHasBeenSet = vm => new Promise(function (resolve, reject) {
let timeout = 3000;
(function waitForGridReady() {
if (timeout === 0) {
reject(new Error('Timeout while waiting for AG Grid to initialise'))
}
// we need to wait for the gridReady event before we can start interacting with the grid
// in this case we're looking at the api property in our App component,
// but it could be anything (ie a boolean flag)
if (vm.$data.api) {
// once our condition has been met we can start the tests
return resolve();
}
// not set - wait a bit longer
timeout -= 10;
setTimeout(waitForGridReady, 10);
})();
});We can now use this utility method before each test or in the beforeEach to ensure the Grid is fully ready before continuing with out test:
beforeEach((done) => {
wrapper = mount(GridExample, {});
// don't start our tests until the grid is ready
// it doesn't take long for the grid to initialise, but it is some finite amount of time
// after the component is ready
ensureGridApiHasBeenSet(wrapper.vm).then(() => done());
}); Vue Testing Library Copy Link
An alternative approach would be to use the Vue Testing Library to test AG Grid. This comes with built in support for handling asynchronous behaviour which you may find easier to work with.
Testing User Supplied Components Copy Link
For example, let us suppose a user provides a custom Editor Component and wants to test this within the context of the Grid.
// Editor Component - Editor.vue
<template>
<input v-model="value" type="number" style="width: 100%">
</template>
<script>
export default {
name: 'Editor',
data() {
return {
value: null
}
},
beforeMount() {
this.value = this.params.value;
},
methods: {
getValue() {
return this.value;
},
// for testing
setValue(newValue) {
this.value = newValue;
},
isCancelBeforeStart() {
return false;
},
isCancelAfterEnd() {
return false;
}
}
}
</script>
<template>
<ag-grid-vue style="width: 500px; height: 500px;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:rowData="rowData">
</ag-grid-vue>
</template>
<script>
import {AgGridVue} from "ag-grid-vue3";
import Editor from './Editor.vue';
export default {
name: 'App',
data() {
return {
columnDefs: null,
rowData: null,
api: null
}
},
components: {
AgGridVue,
Editor
},
beforeMount() {
this.columnDefs = [
{field: 'make'},
{
field: 'price',
editable: true,
cellEditor: 'Editor'
}
];
this.rowData = [
{make: 'Toyota', price: '35000'},
];
},
methods: {
onGridReady(params) {
this.api = params.api;
}
}
}
</script>We can test the interaction between the Grid and the Editor component via the Grid API:
it('grid renders as expected', () => {
const cells = wrapper.findAll('.ag-cell-value');
expect(cells.length).toEqual(2);
expect(cells.at(0).text()).toEqual('Toyota');
expect(cells.at(1).text()).toEqual('35000');
});
it('cell should be editable and editor component usable', () => {
// wait for the api to be set before continuing
const componentInstance = wrapper.vm;
const api = componentInstance.$data.api;
// we use the API to start and stop editing - in a real e2e test we could actually
// double click on the cell etc
api.startEditingCell({
rowIndex: 0,
colKey: 'price'
});
// update the editor input
const textInput = wrapper.find('input[type="number"]');
textInput.setValue(100000);
// stop editing
api.stopEditing();
// test the resulting values in the grid (the edited cell value should have changed)
const cells = wrapper.findAll('.ag-cell-value');
expect(cells.length).toEqual(2);
expect(cells.at(0).text()).toEqual('Toyota');
expect(cells.at(1).text()).toEqual('100000');
});We use the Grid API to initiate and end testing as we can't readily perform double clicks in a unit testing environment (but could if doing e2e with something like Playwright for example).
jsdom Limitations Copy Link
Test tools such as vitest, Dom Testing Library and Jest often rely on jsdom to mock the browser.
jsdom is a pure JavaScript implementation of many web standards with the goal to emulate enough of a subset of a web browser to be useful for testing. However, there are some limitations to be aware of when using jsdom.
If you are using jsdom for testing, you may encounter issues that suggest the grid is not rendering correctly. However, this is likely caused by jsdom not supporting all the features of a real browser.
The main limitations that can affect AG Grid are:
- No support for CSS layout - impacts column / row virtualisation
- No support for
innerTextproperty Issue #1245 - impacts some grid components
If you wish to use jsdom for your tests you may find the following polyfill useful if you encounter issues with missing content due to the use of innerText:
// Override the innerText setter to use textContent instead within jsdom based tests
Object.defineProperty(Element.prototype, 'innerText', {
set(value) {
this.textContent = value;
},
});Where you implement this polyfill may vary depending on your testing setup.
Retrieving References to Grid API and Grid Container Element Copy Link
The following two utility functions are made available for convenience during testing:
import { getGridApi, getGridElement } from 'ag-grid-community'
// Retrieve a GridApi instance from a DOM node/selector
const api = getGridApi('#myGrid');
// Retrieve a Grid `Element` instance from a GridApi instance
const element = getGridElement(api);The getGridApi function returns a GridApi instance that is associated with the grid rendered in gridElement. The gridElement argument can be one of the following: the grid ID as determined by the gridId grid option, a DOM node, or a CSS selector string.
It is recommended to use the gridId as the argument.
The getGridElement function returns the Element instance associated with the grid instance referred to by GridApi.

Testing ag-Grid
We will walk through how you can use testing ag-Grid as part of your React application, using default build tools provided when using the Create React App utility.
Waiting for the Grid to be Initialised
Due to the asynchronous nature of React we cannot simply mount the Grid and assume it'll be ready for testing in the next step - we need to wait for the Grid to be ready before testing it.
We can do this in one of two ways - wait for the gridReady
event to be fired, or wait for the
Grid API to be set.
The first requires a code change and can be tricky to hook into - the latter is unobtrusive and easier to use.
We can create a utility function that will wait for the Grid API to be set for a set amount of time/attempts:
export const ensureGridApiHasBeenSet = component => {
return waitForAsyncCondition(() => {
return component.instance().api !== undefined
}, 5)
};
export const waitForAsyncCondition = (condition, maxAttempts, attempts = 0) => new Promise(function (resolve, reject) {
(function waitForCondition() {
// we need to wait for the gridReady event before we can start interacting with the grid
// in this case we're looking at the api property in our App component, but it could be
// anything (ie a boolean flag)
if (condition()) {
// once our condition has been met we can start the tests
return resolve();
}
attempts++;
if (attempts >= maxAttempts) {
reject("Max timeout waiting for condition")
}
// not set - wait a bit longer
setTimeout(waitForCondition, 10);
})();
});
The first function is what we'll use to wait for the Grid API - the 2nd one is more generic and will be useful for waiting for Grid components to be ready (see later).
We can use ensureGridApiHasBeenSet
before our tests are executed, typically in the beforeEach
hook:
beforeEach((done) => {
component = mount((<GridWithStatefullComponent/>));
agGridReact = component.find(AgGridReact).instance();
// don't start our tests until the grid is ready
ensureGridApiHasBeenSet(component).then(() => done(), () => fail("Grid API not set within expected time limits"));
});
it('stateful component returns a valid component instance', () => {
expect(agGridReact.api).toBeTruthy();
// ..use the Grid API...
});
We can now safely test the Grid component safe in the knowledge that it's been fully initialised.
Waiting for Grid Components to be Instantiated
In the same way we need to wait for the Grid to be ready we also need to do something similar for user supplied Grid components.
For example, let us suppose a user provides a custom Editor Component and wants to test this within the context of the Grid.
class EditorComponent extends Component {
constructor(props) {
super(props);
this.state = {
value: this.props.value
}
}
render() {
return (
<input type="text"
value={this.state.value}
onChange={this.handleChange}
style=<span ng-non-bindable>{</span>{width: "100%"}} />
)
}
handleChange = (event) => {
this.setState({value: event.target.value});
}
getValue() {
return this.state.value;
}
// for testing
setValue(newValue) {
this.setState({
value: newValue
})
}
isCancelBeforeStart() {
return false;
}
isCancelAfterEnd() {
return false;
};
}
class GridWithStatefullComponent extends Component {
constructor(props) {
super(props);
this.state = {
columnDefs: [{
field: "age",
editable: true,
cellEditorFramework: EditorComponent
}],
rowData: [{ age: 24 }]
};
}
onGridReady(params) {
this.api = params.api;
}
render() {
return (
<div className="ag-theme-balham">
<AgGridReact
columnDefs={this.state.columnDefs}
onGridReady={this.onGridReady.bind(this)}
rowData={this.state.rowData} />
</div>
);
}
}
We can now test this Editor Component by using the Grid API to initiate testing, gain access to the created Editor Instance and then invoke methods on it:
it('cell should be editable and editor component usable', async() => {
expect(component.render().find('.ag-cell-value').html()).toEqual(`<div>Age: 24</div>`);
// we use the API to start and stop editing
// in a real e2e test we could actually double click on the cell etc
agGridReact.api.startEditingCell({
rowIndex: 0,
colKey: 'age'
});
await waitForAsyncCondition(
() => agGridReact.api.getCellEditorInstances() &&
agGridReact.api.getCellEditorInstances().length > 0, 5)
.then(() => null, () => fail("Editor instance not created within expected time"));
const instances = agGridReact.api.getCellEditorInstances();
expect(instances.length).toEqual(1);
const editorComponent = instances[0].getFrameworkComponentInstance();
editorComponent.setValue(50);
agGridReact.api.stopEditing();
await waitForAsyncCondition(
() => agGridReact.api.getCellRendererInstances() &&
agGridReact.api.getCellRendererInstances().length > 0, 5)
.then(() => null, () => fail("Renderer instance not created within expected time"));
expect(component.render().find('.ag-cell-value').html()).toEqual(`<div>Age: 50</div>`);
});
Note that we make use of the waitForAsyncCondition
utility described above to wait for
the Editor Component to be instantiated.
We also use the Grid API to initiate and end testing as we're can't readily perform double clicks in a unit testing environment (but could if doing e2e with something like Protractor for example).
- Unit Testing with Jasmine - Waiting for the API
- End to End (e2e) Testing
- Testing Dependencies
- Selenium Server
- Sample Configuration
- Sample Test
- Checking Headers
- Checking Grid Data
- ag-Grid Testing Utilities
- verifyRowDataMatchesGridData
- verifyCellContentAttributesContains
- allElementsTextMatch
- clickOnHeader
- getLocatorForCell
- getCellContentsAsText
- Configuring the Test Module
- Testing via the Grid API
- Testing Grid Contents
- Testing User Supplied Components
- Applying Styles To The Grid When Testing
- Waiting for the Grid to be Initialised
- Waiting for Grid Components to be Instantiated
- Waiting for the Grid to be Initialised
- Testing User Supplied Components
- Jest Configuration
- <code class="language-text">SyntaxError: Cannot use import statement outside a module</code>

Testing ag-Grid
We will walk through how you can use testing ag-Grid as part of your Angular application, using default build tools provided when using the Angular CLI.
Configuring the Test Module
The first thing we need to do is to add ag-Grid's AgGridModule
to the TestBed.configureTestingModule(
:
beforeEach(async(() => {
TestBed.configureTestingModule({
imports: [
FormsModule,
AgGridModule.withComponents([])
],
declarations: [TestHostComponent]
}).compileComponents();
fixture = TestBed.createComponent(TestHostComponent);
component = fixture.componentInstance;
fixture.detectChanges();
}));
Now that the test bed is aware of ag-Grid we can continue with our testing. If however you wish to add any user provided components to the grid then you'll need to declare them here too:
beforeEach(async(() => {
TestBed.configureTestingModule({
imports: [
FormsModule,
+ AgGridModule.withComponents([RendererComponent, EditorComponent])
],
+ declarations: [TestHostComponent, RendererComponent, EditorComponent]
}).compileComponents();
fixture = TestBed.createComponent(TestHostComponent);
component = fixture.componentInstance;
fixture.detectChanges();
}));
Here were initialising the test bed before each test for convenience.
Testing via the Grid API
The grid's API will only be ready after detectChanges
has been run:
it('grid API is not available until `detectChanges`', () => {
expect(component.gridOptions.api).not.toBeTruthy();
});
it('grid API is available after `detectChanges`', () => {
fixture.detectChanges();
expect(component.gridOptions.api).toBeTruthy();
});
Testing Grid Contents
The easiest way to check the grid contents is to access the nativeElement
and query DOM elements from there:
it('the grid cells should be as expected', () => {
const appElement = fixture.nativeElement;
const cellElements = appElement.querySelectorAll('.ag-cell-value');
expect(cellElements.length).toEqual(3);
expect(cellElements[0].textContent).toEqual("Test Name");
expect(cellElements[1].textContent).toEqual("42");
expect(cellElements[2].textContent).toEqual("84");
});
Testing User Supplied Components
The easiest way to test user supplied components is to access them via getFrameworkComponentInstance
.
For example, given the following code:
@Component(<span ng-non-bindable>{</span>
selector: 'editor-cell',
template: `<input #input [(ngModel)]="value" style="width: 100%">`
<span ng-non-bindable>}</span>
)
export class EditorComponent implements ICellEditorAngularComp {
private params: any;
public value: number;
@ViewChild('input', {read: ViewContainerRef}) public input;
agInit(params: any): void {
this.params = params;
this.value = this.params.value;
}
getValue(): any {
return this.value;
}
// for testing
setValue(newValue: any) {
this.value = newValue;
}
isCancelBeforeStart(): boolean {
return false;
}
isCancelAfterEnd(): boolean {
return false;
};
}
@Component({
template:
`<div>
<ag-grid-angular
style="width: 100%; height: 350px;" class="ag-theme-alpine"
[columnDefs]="columnDefs"
[rowData]="rowData"
[stopEditingWhenGridLosesFocus]="false"
[frameworkComponents]="frameworkComponents"
(gridReady)="onGridReady($event)">
</ag-grid-angular>
</div>`
})
class TestHostComponent {
rowData: any[] = [{name: 'Test Name', number: 42}];
columnDefs: any[] = [
{field: "name"},
{field: "number", colId: "raw", headerName: "Raw Number", editable: true, cellEditor: 'editor'},
{field: "number", colId: "renderer", headerName: "Renderer Value"}
];
frameworkComponents = {
'editor': EditorComponent
};
api: GridApi;
columnApi: ColumnApi;
public onGridReady(params) {
this.api = params.api;
this.columnApi = params.columnApi;
}
}
We can test that the EditorComponent
works as follows:
it('cell should be editable and editor component usable', () => {
// we use the API to start and stop editing - in a real e2e test we could actually double click on the cell etc
component.api.startEditingCell({
rowIndex: 0,
colKey: 'raw'
});
const instances = component.api.getCellEditorInstances();
expect(instances.length).toEqual(1);
const editorComponent = instances[0].getFrameworkComponentInstance();
editorComponent.setValue(100);
component.api.stopEditing();
const appElement = fixture.nativeElement;
const cellElements = appElement.querySelectorAll('.ag-cell-value');
expect(cellElements.length).toEqual(3);
expect(cellElements[0].textContent).toEqual("Test Name");
expect(cellElements[1].textContent).toEqual("100");
expect(cellElements[2].textContent).toEqual("200");
});
Applying Styles To The Grid When Testing
Although not strictly necessary when unit testing the grid, it is still useful to see the grid
rendered when debugging. In order for this to work you need to provide the CSS to karma.conf.js
:
// not strictly required for testing but useful when debugging the grid in action
files: [
'../node_modules/ag-grid-community/dist/styles/ag-grid.css',
'../node_modules/ag-grid-community/dist/styles/ag-theme-alpine.css'
]
- Unit Testing with Jasmine - Waiting for the API
- End to End (e2e) Testing
- Testing Dependencies
- Selenium Server
- Sample Configuration
- Sample Test
- Checking Headers
- Checking Grid Data
- ag-Grid Testing Utilities
- verifyRowDataMatchesGridData
- verifyCellContentAttributesContains
- allElementsTextMatch
- clickOnHeader
- getLocatorForCell
- getCellContentsAsText
- Configuring the Test Module
- Testing via the Grid API
- Testing Grid Contents
- Testing User Supplied Components
- Applying Styles To The Grid When Testing
- Waiting for the Grid to be Initialised
- Waiting for Grid Components to be Instantiated
- Waiting for the Grid to be Initialised
- Testing User Supplied Components
- Jest Configuration
- <code class="language-text">SyntaxError: Cannot use import statement outside a module</code>